import os

import pandas as pd
import torch
import torch.nn.functional as F
from PIL import Image
from torch.optim import AdamW
from torch.optim.lr_scheduler import CosineAnnealingLR
from torch.utils.data import DataLoader
from tqdm import tqdm

from model import  network
from utils import parse_args, UIEDataset
import time


def test_loop(net, data_loader, num_iter):
    net.eval()
    count = 0
    with torch.no_grad():
        
        for Input, gt, name, h, w in data_loader:
            Input = Input.cuda()
            
            out = torch.clamp((torch.clamp(model(Input)[:, :, :h, :w], 0, 1).mul(255)), 0, 255).byte()
            
            
            
            
        
            count += 1
            save_path = '{}/{}/{}'.format(args.save_path, args.data_name, name[0])
            if not os.path.exists(os.path.dirname(save_path)):
                os.makedirs(os.path.dirname(save_path))
            Image.fromarray(out.squeeze(dim=0).permute(1, 2, 0).contiguous().cpu().numpy()).save(save_path)
    


def save_loop(net, data_loader, num_iter):
    
    test_loop(net, data_loader, num_iter)
    
    

if __name__ == '__main__':
    args = parse_args()
    test_dataset = UIEDataset(args.data_path_test, args.data_path_test, args.data_name, 'test')
    test_loader = DataLoader(test_dataset, batch_size=1, shuffle=False, num_workers=args.workers)

    results, best_psnr, best_ssim = {'PSNR': [], 'SSIM': []}, 0.0, 0.0
    model = network(args.inp_channels, args.out_channels, args.dim, args.num_blocks, args.num_refinement_blocks,args.ffn_expansion_factor,args.bias).cuda()
    
      
    
    

    if args.model_file:
        model.load_state_dict(torch.load(args.model_file))
        save_loop(model, test_loader, 1)
    print("=============  TESTING DONE  =============")
